diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h ns-3.36/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h
--- ns-3.35/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/itu-r-1411-nlos-over-rooftop-propagation-loss-model.h	2022-04-30 18:23:58.130735000 -0700
@@ -53,6 +53,10 @@
   ItuR1411NlosOverRooftopPropagationLossModel ();
   virtual ~ItuR1411NlosOverRooftopPropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  ItuR1411NlosOverRooftopPropagationLossModel (const ItuR1411NlosOverRooftopPropagationLossModel &) = delete;
+  ItuR1411NlosOverRooftopPropagationLossModel & operator = (const ItuR1411NlosOverRooftopPropagationLossModel &) = delete;
+
   /** 
    * Set the operating frequency
    * 
@@ -72,25 +76,11 @@
   double GetLoss (Ptr<MobilityModel> a, Ptr<MobilityModel> b) const;
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  ItuR1411NlosOverRooftopPropagationLossModel (const ItuR1411NlosOverRooftopPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  ItuR1411NlosOverRooftopPropagationLossModel & operator = (const ItuR1411NlosOverRooftopPropagationLossModel &);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
+  int64_t DoAssignStreams (int64_t stream) override;
 
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
-  
   double m_frequency; //!< frequency in MHz
   double m_lambda; //!< wavelength
   EnvironmentType m_environment; //!< Environment Scenario
@@ -107,4 +97,3 @@
 
 
 #endif // ITU_R_1411_NLOS_OVER_ROOFTOP_PROPAGATION_LOSS_MODEL_H
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/jakes-propagation-loss-model.h ns-3.36/src/propagation/model/jakes-propagation-loss-model.h
--- ns-3.35/src/propagation/model/jakes-propagation-loss-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/jakes-propagation-loss-model.h	2022-04-30 18:23:58.130735000 -0700
@@ -43,27 +43,19 @@
   static TypeId GetTypeId ();
   JakesPropagationLossModel ();
   virtual ~JakesPropagationLossModel ();
-  
+
+  // Delete copy constructor and assignment operator to avoid misuse
+  JakesPropagationLossModel (const JakesPropagationLossModel &) = delete;
+  JakesPropagationLossModel & operator = (const JakesPropagationLossModel &) = delete;
+
 private:
   friend class JakesProcess;
 
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  JakesPropagationLossModel (const JakesPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  JakesPropagationLossModel & operator = (const JakesPropagationLossModel &);
   double DoCalcRxPower (double txPowerDbm,
                         Ptr<MobilityModel> a,
-                        Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
+                        Ptr<MobilityModel> b) const override;
+
+  int64_t DoAssignStreams (int64_t stream) override;
 
   /**
    * Get the underlying RNG stream
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/kun-2600-mhz-propagation-loss-model.h ns-3.36/src/propagation/model/kun-2600-mhz-propagation-loss-model.h
--- ns-3.35/src/propagation/model/kun-2600-mhz-propagation-loss-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/kun-2600-mhz-propagation-loss-model.h	2022-04-30 18:23:58.130735000 -0700
@@ -51,6 +51,10 @@
   Kun2600MhzPropagationLossModel ();
   virtual ~Kun2600MhzPropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  Kun2600MhzPropagationLossModel (const Kun2600MhzPropagationLossModel &) = delete;
+  Kun2600MhzPropagationLossModel & operator = (const Kun2600MhzPropagationLossModel &) = delete;
+
   /** 
    * \param a the first mobility model
    * \param b the second mobility model
@@ -61,26 +65,11 @@
   double GetLoss (Ptr<MobilityModel> a, Ptr<MobilityModel> b) const;
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  Kun2600MhzPropagationLossModel (const Kun2600MhzPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  Kun2600MhzPropagationLossModel & operator = (const Kun2600MhzPropagationLossModel &);
-
   // inherited from PropagationLossModel
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
-  
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
+  int64_t DoAssignStreams (int64_t stream) override;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/okumura-hata-propagation-loss-model.h ns-3.36/src/propagation/model/okumura-hata-propagation-loss-model.h
--- ns-3.35/src/propagation/model/okumura-hata-propagation-loss-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/okumura-hata-propagation-loss-model.h	2022-04-30 18:23:58.130735000 -0700
@@ -54,6 +54,10 @@
   OkumuraHataPropagationLossModel ();
   virtual ~OkumuraHataPropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  OkumuraHataPropagationLossModel (const OkumuraHataPropagationLossModel &) = delete;
+  OkumuraHataPropagationLossModel & operator = (const OkumuraHataPropagationLossModel &) = delete;
+
   /** 
    * \param a the first mobility model
    * \param b the second mobility model
@@ -64,25 +68,11 @@
   double GetLoss (Ptr<MobilityModel> a, Ptr<MobilityModel> b) const;
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  OkumuraHataPropagationLossModel (const OkumuraHataPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  OkumuraHataPropagationLossModel & operator = (const OkumuraHataPropagationLossModel &);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
+  int64_t DoAssignStreams (int64_t stream) override;
 
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
-  
   EnvironmentType m_environment;  //!< Environment Scenario
   CitySize m_citySize;  //!< Size of the city
   double m_frequency; //!< frequency in Hz
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/propagation-delay-model.h ns-3.36/src/propagation/model/propagation-delay-model.h
--- ns-3.35/src/propagation/model/propagation-delay-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/propagation-delay-model.h	2022-04-30 18:23:58.130735000 -0700
@@ -58,14 +58,19 @@
    * 'stream'.  Return the number of streams (possibly zero) that
    * have been assigned.
    *
-   * \param stream
+   * \param stream first stream index to use
    * \return the number of stream indices assigned by this model
    */
   int64_t AssignStreams (int64_t stream);
-private:
+protected:
   /**
+   * Assign a fixed random variable stream number to the random variables used by this model.
+   * 
    * Subclasses must implement this; those not using random variables
-   * can return zero
+   * can return zero.
+   * 
+   * \param stream first stream index to use
+   * \return the number of stream indices assigned by this model
    */
   virtual int64_t DoAssignStreams (int64_t stream) = 0;
 };
@@ -89,9 +94,9 @@
    */
   RandomPropagationDelayModel ();
   virtual ~RandomPropagationDelayModel ();
-  virtual Time GetDelay (Ptr<MobilityModel> a, Ptr<MobilityModel> b) const;
+  Time GetDelay (Ptr<MobilityModel> a, Ptr<MobilityModel> b) const override;
 private:
-  virtual int64_t DoAssignStreams (int64_t stream);
+  int64_t DoAssignStreams (int64_t stream) override;
   Ptr<RandomVariableStream> m_variable; //!< random generator
 };
 
@@ -113,7 +118,7 @@
    * Use the default parameters from PropagationDelayConstantSpeed.
    */
   ConstantSpeedPropagationDelayModel ();
-  virtual Time GetDelay (Ptr<MobilityModel> a, Ptr<MobilityModel> b) const;
+  Time GetDelay (Ptr<MobilityModel> a, Ptr<MobilityModel> b) const override;
   /**
    * \param speed the new speed (m/s)
    */
@@ -123,7 +128,7 @@
    */
   double GetSpeed (void) const;
 private:
-  virtual int64_t DoAssignStreams (int64_t stream);
+  int64_t DoAssignStreams (int64_t stream) override;
   double m_speed; //!< speed
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/propagation-loss-model.h ns-3.36/src/propagation/model/propagation-loss-model.h
--- ns-3.35/src/propagation/model/propagation-loss-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/propagation-loss-model.h	2022-04-30 18:23:58.130735000 -0700
@@ -33,7 +33,12 @@
 
 /**
  * \defgroup propagation Propagation Models
- *
+ */
+
+/**
+ * \ingroup propagation
+ * \ingroup tests
+ * \defgroup propagation-tests Propagation module tests
  */
 
 class MobilityModel;
@@ -59,6 +64,10 @@
   PropagationLossModel ();
   virtual ~PropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  PropagationLossModel (const PropagationLossModel &) = delete;
+  PropagationLossModel & operator = (const PropagationLossModel &) = delete;
+
   /**
    * \brief Enables a chain of loss models to act on the signal
    * \param next The next PropagationLossModel to add to the chain
@@ -101,28 +110,25 @@
    * together, this method will also assign streams to the
    * downstream models.
    *
-   * \param stream
+   * \param stream the stream index offset start
    * \return the number of stream indices assigned by this model
    */
   int64_t AssignStreams (int64_t stream);
 
-private:
+protected:
   /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  PropagationLossModel (const PropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
+   * Assign a fixed random variable stream number to the random variables used by this model.
+   * 
+   * Subclasses must implement this; those not using random variables
+   * can return zero.
+   * 
+   * \param stream first stream index to use
+   * \return the number of stream indices assigned by this model
    */
-  PropagationLossModel &operator = (const PropagationLossModel &);
+  virtual int64_t DoAssignStreams (int64_t stream) = 0;
 
+private:
   /**
-   * Returns the Rx Power taking into account only the particular
    * PropagationLossModel.
    *
    * \param txPowerDbm current transmission power (in dBm)
@@ -134,12 +140,6 @@
                                 Ptr<MobilityModel> a,
                                 Ptr<MobilityModel> b) const = 0;
 
-  /**
-   * Subclasses must implement this; those not using random variables
-   * can return zero
-   */
-  virtual int64_t DoAssignStreams (int64_t stream) = 0;
-
   Ptr<PropagationLossModel> m_next; //!< Next propagation loss model in the list
 };
 
@@ -160,24 +160,16 @@
   RandomPropagationLossModel ();
   virtual ~RandomPropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  RandomPropagationLossModel (const RandomPropagationLossModel &) = delete;
+  RandomPropagationLossModel & operator = (const RandomPropagationLossModel &) = delete;
+
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  RandomPropagationLossModel (const RandomPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  RandomPropagationLossModel & operator = (const RandomPropagationLossModel &);
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
+  int64_t DoAssignStreams (int64_t stream) override;
+
   Ptr<RandomVariableStream> m_variable; //!< random generator
 };
 
@@ -267,6 +259,11 @@
    */
   static TypeId GetTypeId (void);
   FriisPropagationLossModel ();
+
+  // Delete copy constructor and assignment operator to avoid misuse
+  FriisPropagationLossModel (const FriisPropagationLossModel &) = delete;
+  FriisPropagationLossModel & operator = (const FriisPropagationLossModel &) = delete;
+
   /**
    * \param frequency (Hz)
    *
@@ -304,24 +301,10 @@
   double GetSystemLoss (void) const;
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  FriisPropagationLossModel (const FriisPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  FriisPropagationLossModel & operator = (const FriisPropagationLossModel &);
-
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
+  int64_t DoAssignStreams (int64_t stream) override;
 
   /**
    * Transforms a Dbm value to Watt
@@ -381,6 +364,10 @@
   static TypeId GetTypeId (void);
   TwoRayGroundPropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  TwoRayGroundPropagationLossModel (const TwoRayGroundPropagationLossModel &) = delete;
+  TwoRayGroundPropagationLossModel & operator = (const TwoRayGroundPropagationLossModel &) = delete;
+
   /**
    * \param frequency (Hz)
    *
@@ -424,24 +411,10 @@
   void SetHeightAboveZ (double heightAboveZ);
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  TwoRayGroundPropagationLossModel (const TwoRayGroundPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  TwoRayGroundPropagationLossModel & operator = (const TwoRayGroundPropagationLossModel &);
-
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
+  int64_t DoAssignStreams (int64_t stream) override;
 
   /**
    * Transforms a Dbm value to Watt
@@ -494,6 +467,10 @@
   static TypeId GetTypeId (void);
   LogDistancePropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  LogDistancePropagationLossModel (const LogDistancePropagationLossModel &) = delete;
+  LogDistancePropagationLossModel & operator = (const LogDistancePropagationLossModel &) = delete;
+
   /**
    * \param n the path loss exponent.
    * Set the path loss exponent.
@@ -512,24 +489,11 @@
   void SetReference (double referenceDistance, double referenceLoss);
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  LogDistancePropagationLossModel (const LogDistancePropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  LogDistancePropagationLossModel & operator = (const LogDistancePropagationLossModel &);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
 
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
+  int64_t DoAssignStreams (int64_t stream) override;
 
   /**
    *  Creates a default reference loss model
@@ -592,27 +556,18 @@
   static TypeId GetTypeId (void);
   ThreeLogDistancePropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  ThreeLogDistancePropagationLossModel (const ThreeLogDistancePropagationLossModel &) = delete;
+  ThreeLogDistancePropagationLossModel & operator = (const ThreeLogDistancePropagationLossModel &) = delete;
+
   // Parameters are all accessible via attributes.
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  ThreeLogDistancePropagationLossModel (const ThreeLogDistancePropagationLossModel&);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  ThreeLogDistancePropagationLossModel& operator= (const ThreeLogDistancePropagationLossModel&);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
 
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
+  int64_t DoAssignStreams (int64_t stream) override;
 
   double m_distance0; //!< Beginning of the first (near) distance field
   double m_distance1; //!< Beginning of the second (middle) distance field.
@@ -663,27 +618,18 @@
 
   NakagamiPropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  NakagamiPropagationLossModel (const NakagamiPropagationLossModel &) = delete;
+  NakagamiPropagationLossModel & operator = (const NakagamiPropagationLossModel &) = delete;
+
   // Parameters are all accessible via attributes.
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  NakagamiPropagationLossModel (const NakagamiPropagationLossModel&);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  NakagamiPropagationLossModel& operator= (const NakagamiPropagationLossModel&);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
 
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
+  int64_t DoAssignStreams (int64_t stream) override;
 
   double m_distance1; //!< Distance1
   double m_distance2; //!< Distance2
@@ -720,6 +666,11 @@
 
   FixedRssLossModel ();
   virtual ~FixedRssLossModel ();
+
+  // Delete copy constructor and assignment operator to avoid misuse
+  FixedRssLossModel (const FixedRssLossModel &) = delete;
+  FixedRssLossModel & operator = (const FixedRssLossModel &) = delete;
+
   /**
    * \param rss (dBm) the received signal strength
    *
@@ -728,25 +679,12 @@
   void SetRss (double rss);
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  FixedRssLossModel (const FixedRssLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  FixedRssLossModel & operator = (const FixedRssLossModel &);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
 
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
+  int64_t DoAssignStreams (int64_t stream) override;
 
-  virtual int64_t DoAssignStreams (int64_t stream);
   double m_rss; //!< the received signal strength
 };
 
@@ -769,6 +707,10 @@
   MatrixPropagationLossModel ();
   virtual ~MatrixPropagationLossModel ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  MatrixPropagationLossModel (const MatrixPropagationLossModel &) = delete;
+  MatrixPropagationLossModel & operator = (const MatrixPropagationLossModel &) = delete;
+
   /**
    * \brief Set loss (in dB, positive) between pair of ns-3 objects
    * (typically, nodes).
@@ -787,26 +729,12 @@
   void SetDefaultLoss (double defaultLoss);
 
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  MatrixPropagationLossModel (const MatrixPropagationLossModel &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  MatrixPropagationLossModel &operator = (const MatrixPropagationLossModel &);
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
 
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
+  int64_t DoAssignStreams (int64_t stream) override;
 
-  virtual int64_t DoAssignStreams (int64_t stream);
-private:
   double m_default; //!< default loss
 
   /// Typedef: Mobility models pair
@@ -834,25 +762,18 @@
    */
   static TypeId GetTypeId (void);
   RangePropagationLossModel ();
+
+  // Delete copy constructor and assignment operator to avoid misuse
+  RangePropagationLossModel (const RangePropagationLossModel &) = delete;
+  RangePropagationLossModel & operator = (const RangePropagationLossModel &) = delete;
+
 private:
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   */
-  RangePropagationLossModel (const RangePropagationLossModel&);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and unimplemented to avoid misuse
-   * \returns
-   */
-  RangePropagationLossModel& operator= (const RangePropagationLossModel&);
-  virtual double DoCalcRxPower (double txPowerDbm,
-                                Ptr<MobilityModel> a,
-                                Ptr<MobilityModel> b) const;
-  virtual int64_t DoAssignStreams (int64_t stream);
-private:
+  double DoCalcRxPower (double txPowerDbm,
+                        Ptr<MobilityModel> a,
+                        Ptr<MobilityModel> b) const override;
+
+  int64_t DoAssignStreams (int64_t stream) override;
+
   double m_range; //!< Maximum Transmission Range (meters)
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/three-gpp-propagation-loss-model.cc ns-3.36/src/propagation/model/three-gpp-propagation-loss-model.cc
--- ns-3.35/src/propagation/model/three-gpp-propagation-loss-model.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/three-gpp-propagation-loss-model.cc	2022-04-30 18:23:58.130735000 -0700
@@ -32,7 +32,7 @@
 
 NS_LOG_COMPONENT_DEFINE ("ThreeGppPropagationLossModel");
 
-static const double M_C = 3.0e8; // propagation velocity in free space
+static const double M_C = 3.0e8; //!< propagation velocity in free space
 
 // ------------------------------------------------------------------------- //
 
@@ -480,9 +480,8 @@
 }
 
 double
-ThreeGppRmaPropagationLossModel::Pl1 (double frequency, double distance3D, double h, double w)
+ThreeGppRmaPropagationLossModel::Pl1 (double frequency, double distance3D, double h, [[maybe_unused]] double w)
 {
-  NS_UNUSED (w);
   double loss = 20.0 * log10 (40.0 * M_PI * distance3D * frequency / 1e9 / 3.0) + std::min (0.03 * pow (h, 1.72), 10.0) * log10 (distance3D) - std::min (0.044 * pow (h, 1.72), 14.77) + 0.002 * log10 (h) * distance3D;
   return loss;
 }
@@ -651,11 +650,11 @@
 }
 
 double
-ThreeGppUmaPropagationLossModel::GetShadowingStd (Ptr<MobilityModel> a, Ptr<MobilityModel> b, ChannelCondition::LosConditionValue cond) const
+ThreeGppUmaPropagationLossModel::GetShadowingStd ([[maybe_unused]] Ptr<MobilityModel> a, 
+                                                  [[maybe_unused]] Ptr<MobilityModel> b, 
+                                                  ChannelCondition::LosConditionValue cond) const
 {
   NS_LOG_FUNCTION (this);
-  NS_UNUSED (a);
-  NS_UNUSED (b);
   double shadowingStd;
 
   if (cond == ChannelCondition::LosConditionValue::LOS)
@@ -736,10 +735,10 @@
 }
 
 double
-ThreeGppUmiStreetCanyonPropagationLossModel::GetBpDistance (double hUt, double hBs, double distance2D) const
+ThreeGppUmiStreetCanyonPropagationLossModel::GetBpDistance (double hUt, double hBs, 
+                                                            [[maybe_unused]] double distance2D) const
 {
   NS_LOG_FUNCTION (this);
-  NS_UNUSED (distance2D);
 
   // compute hE (see 3GPP TR 38.901, Table 7.4.1-1, Note 1)
   double hE = 1.0;
@@ -868,11 +867,11 @@
 }
 
 double
-ThreeGppUmiStreetCanyonPropagationLossModel::GetShadowingStd (Ptr<MobilityModel> a, Ptr<MobilityModel> b, ChannelCondition::LosConditionValue cond) const
+ThreeGppUmiStreetCanyonPropagationLossModel::GetShadowingStd ([[maybe_unused]] Ptr<MobilityModel> a, 
+                                                              [[maybe_unused]] Ptr<MobilityModel> b, 
+                                                              ChannelCondition::LosConditionValue cond) const
 {
   NS_LOG_FUNCTION (this);
-  NS_UNUSED (a);
-  NS_UNUSED (b);
   double shadowingStd;
 
   if (cond == ChannelCondition::LosConditionValue::LOS)
@@ -943,13 +942,12 @@
 }
 
 double
-ThreeGppIndoorOfficePropagationLossModel::GetLossLos (double distance2D, double distance3D, double hUt, double hBs) const
+ThreeGppIndoorOfficePropagationLossModel::GetLossLos ([[maybe_unused]] double distance2D, 
+                                                      [[maybe_unused]] double distance3D, 
+                                                      [[maybe_unused]] double hUt, 
+                                                      [[maybe_unused]] double hBs) const
 {
   NS_LOG_FUNCTION (this);
-  NS_UNUSED (distance2D);
-  NS_UNUSED (distance3D);
-  NS_UNUSED (hUt);
-  NS_UNUSED (hBs);
 
   // check if the distance is outside the validity range
   if (distance3D < 1.0 || distance3D > 150.0)
@@ -986,11 +984,11 @@
 }
 
 double
-ThreeGppIndoorOfficePropagationLossModel::GetShadowingStd (Ptr<MobilityModel> a, Ptr<MobilityModel> b, ChannelCondition::LosConditionValue cond) const
+ThreeGppIndoorOfficePropagationLossModel::GetShadowingStd ([[maybe_unused]] Ptr<MobilityModel> a, 
+                                                           [[maybe_unused]] Ptr<MobilityModel> b, 
+                                                           ChannelCondition::LosConditionValue cond) const
 {
   NS_LOG_FUNCTION (this);
-  NS_UNUSED (a);
-  NS_UNUSED (b);
   double shadowingStd;
 
   if (cond == ChannelCondition::LosConditionValue::LOS)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/model/three-gpp-propagation-loss-model.h ns-3.36/src/propagation/model/three-gpp-propagation-loss-model.h
--- ns-3.35/src/propagation/model/three-gpp-propagation-loss-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/model/three-gpp-propagation-loss-model.h	2022-04-30 18:23:58.130735000 -0700
@@ -26,8 +26,10 @@
 namespace ns3 {
 
 /**
-* \brief Base class for the 3GPP propagation models
-*/
+ * \ingroup propagation
+ * 
+ * \brief Base class for the 3GPP propagation models
+ */
 class ThreeGppPropagationLossModel : public PropagationLossModel
 {
 public:
@@ -101,15 +103,6 @@
                                 Ptr<MobilityModel> a,
                                 Ptr<MobilityModel> b) const override;
 
-  /**
-   * If this  model uses objects of type RandomVariableStream,
-   * set the stream numbers to the integers starting with the offset
-   * 'stream'. Return the number of streams (possibly zero) that
-   * have been assigned.
-   *
-   * \param stream
-   * \return the number of stream indices assigned by this model
-   */
   virtual int64_t DoAssignStreams (int64_t stream) override;
   
   /**
@@ -391,15 +384,6 @@
   ThreeGppUmaPropagationLossModel & operator = (const ThreeGppUmaPropagationLossModel &) = delete;
 
 private:
-  /**
-   * If this  model uses objects of type RandomVariableStream,
-   * set the stream numbers to the integers starting with the offset
-   * 'stream'. Return the number of streams (possibly zero) that
-   * have been assigned.
-   *
-   * \param stream
-   * \return the number of stream indices assigned by this model
-   */
   virtual int64_t DoAssignStreams (int64_t stream) override;
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/propagation/test/channel-condition-model-test-suite.cc ns-3.36/src/propagation/test/channel-condition-model-test-suite.cc
--- ns-3.35/src/propagation/test/channel-condition-model-test-suite.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/propagation/test/channel-condition-model-test-suite.cc	2022-04-30 18:23:58.130735000 -0700
@@ -32,6 +32,8 @@
 NS_LOG_COMPONENT_DEFINE ("ChannelConditionModelsTest");
 
 /**
+ * \ingroup propagation-tests
+ *
  * Test case for the 3GPP channel condition models. It determines the
  * channel condition multiple times, estimates the LOS probability and
  * compares it with the value given by the formulas in 3GPP TR 38.901,
@@ -263,6 +265,8 @@
 }
 
 /**
+ * \ingroup propagation-tests
+ *
  * Test suite for the channel condition models
  */
 class ChannelConditionModelsTestSuite : public TestSuite
@@ -277,4 +281,5 @@
   AddTestCase (new ThreeGppChannelConditionModelTestCase, TestCase::QUICK);
 }
 
-static ChannelConditionModelsTestSuite ChannelConditionModelsTestSuite;
+/// Static variable for test initialization
+static ChannelConditionModelsTestSuite g_channelConditionModelsTestSuite;
